/*
 * $Id: //depot/jhttpd/docs/dbml/dblayout.js#23 $
 *
 * COPYRIGHT(C) 2003 Coldwave Programs Ltd. ALL RIGHTS RESERVED
 *
 * By downloading this software you have agreed to the following terms:
 * This software is available free for individual use or evaluation only.
 * If you wish to incorporate ANY of the code in this release into
 * a product or production application a source license is required.
 * This software may not be redistributed whole or in part.
 *
 * THIS SOFTWARE IS PROVIDED BY COLDWAVE PROGRAMS LTD "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL COLDWAVE PROGRAMS LTD OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


function DBLayout() {

  window.layoutEditor = this;

  document.onkeydown = this.deleteObject;
  document.body.ondblclick = layoutEditor.openInspector;

  document.body.inspector = "bodyInspector";

  this.lastObj = null;
  this.form = null;
  this.obj = null;

  this.tables = [];

  if ( !document.body.dblayout_js ) {
    var file = document.body.filename || "";
    document.body.dblayout_js = 1;
    document.write( '\
<link rel="stylesheet" href="/dbml/dblayout.css">\
<script src="/dbml/dbml.js"></script>\
<div style="position: absolute; top: expression(document.body.clientHeight-this.offsetHeight+document.body.scrollTop-8);">\
\
<table style="border: 3px inset; background-color: lightgrey; display: none; font: 10pt Arial;">\
<tr><td id="layoutPalette">\
<td valign="top"><form id="dbmlSaver" method="POST" action="save.dbml" onsubmit="return layoutEditor.layoutSave(this);" style="margin-bottom: 0;">\
<input name="html" type="hidden">\
<input name="file" value="'+file+'" size="14" title="Name layout to save to disk">\
<input type="submit" value="Save Layout" accessKey="s"><br>\
For more help using dbml <a href="http://dbexplorer.com/dbml/" target="_blank">click here</a>.\
</table></form>\
</table></div>\
<div id="layoutInspectors" style="display: none; z-Index: 100;">&nbsp;</div>\
<div id="layoutArea"></div>\
<textarea id="log" cols="80" rows="20" style="display:none"></textarea>\
<script>layoutEditor.recoverAlignments();</script></div>\
' );

  }
}

DBLayout.prototype.layoutSave = function(form) {
  var file = form.file.value;
  if ( !file ) {
    alert( "Please enter a name for your new DBML Template" );
    return false;
  }
  
  document.body.filename = file;

  var tables = layoutEditor.tables;
  tables = document.body.getElementsByTagName( "DIV" );
  for ( var i=0 ; i<tables.length ; i++ )
    if ( tables[i] && tables[i].tableAction ) {
      tables[i].innerHTML //= tables[i].loaded
	= '<table width="100%" height="100%"><tr><td></table>';
      tables[i].loaded = "";
  }

  form.html.value = "";
  layoutInspectors.innerHTML = "";
  document.body.outerWidth0 = window.outerWidth;
  document.body.outerHeight0 = window.outerHeight;
  document.body.clientWidth0 = document.body.clientWidth;
  document.body.clientHeight0 = document.body.clientHeight;
  layoutPalette.parentNode.parentNode.parentNode.style.display = "none";
  with ( document.location )
    document.body.defaultSource = "http://"+host+pathname;

  layoutArea.className = "running";
  form.html.value = document.body.outerHTML;

  if ( !document.location.search )
    try { window.opener.location.reload(); } catch (e) {}
  window.onbeforeunload = null;
  return true;
}

DBLayout.prototype.hasChanged = function() {
  event.cancelBubble = true;
  if ( !window.onbeforeunload )
  window.onbeforeunload = function() {
    top.event.returnValue = "         *** You have unsaved layout changes ***";
    return false;
  };
  return false;
};


DBLayout.prototype.writePalette = function() {
  layoutPalette.innerHTML = '<table><tr>\
<td valign="top" dragState="pick" title="This can also be dragged onto the layout as a heading"><div style="font: bold 20pt Arial; ffont-size: expression(this.offsetHeight);" inspector="fieldInspector">Palette</div>\
<td valign="top" dragState="pick" title="Form element which can be the source or target of a query">\
<form inspector="formInspector" style="border:0; width:100; hheight:35; border: 1px outset; margin-bottom: 0;" onsubmit="return dbml.populateTargets(this);">\
<table style="border: 1px inset" width="100%" height="100%"><tr><td align=center valign=bottom>\
<input name="button" type="submit" value=" Query " accessKey="e"></table></form>\
<td valign="top" dragState="pick" title="Drag this element onto a form to form part of the source or target of a query"><table resizer="fieldResizer"><tr><td><span style="font: 12pt Arial;" inspector="fieldInspector">Field:</span><td align="left"><input name="field1" size="1" inspector="fieldInspector"><span></table>\
<td valign="top" dragState="pick" title="Use this element as the target of a query to populate the popup list"><table><tbody><tr><td><span style="font: 12pt Arial;" inspector="popupInspector">Field:</span></td><td><select></select><span></td></tr></table>\
<td valign="top" dragState="pick" title="Use to display tabular data"><div inspector="tableInspector" tableAction="select * from titles" style="width:100; height:35; border: 3px inset; overflow: auto;"><table width="100%" height="100%"><tr><td align=center>Data Table</table></div>\
<td valign="top"><table cellspacing="0" cellpadding="0">\
<tr><td valign="top" dragState="pick" title="Use for groups of check boxes"><input inspector="groupInspector" type="checkbox" name=x value="">\
<tr><td valign="top" dragState="pick" title="Use for radio group"><input inspector="groupInspector" type="radio" name=x value=""></table>\
<td valign=top align=center style="border: 0; position: relative; top: -2;">\
<table cellspacing=0 cellpadding=0 style="font: 10pt Arial;"><tr><td><input id="_grid" type="text" style="text-align: center; width: 22;" value="5"><tr><td>Grid</table>\
</table>';
}

DBLayout.prototype.writeInspectors = function() {

  var colors = [""].concat( "aqua black chocolate cadetblue coral cornflowerblue darkorange darkslateblue white wheat LightGrey ActiveCaption InactiveCaption Menu HighLight ButtonFace InfoBackground bluesky.jpg".split( / / ) );
  var colorOptions = "\n";
  for ( var i=0 ; i<colors.length ; i++ )
    colorOptions += "<option value="+colors[i]+">"+colors[i]+"\n";

  var colorSelector = '<select name="color">'+colorOptions+'</select>';
  var colorOK = '<tr title="Background Color"><td>Color:<td>'+colorSelector+
	'&nbsp;<input type="submit" value=" Ok " title="Save changes">';

  var stdInspector = function(name) {
    return 'class="dbmlInspector" ondblclick="event.cancelBubble=true;" oonclick="event.cancelBubble=true;" dragState="inspector">\
<table cellspacing="0" cellpadding="0">\
<tr class="windowBar" dragState="move"><td>&nbsp;'+name+' Inspector<td align="right">\
<span style="border: outset 2px; background-color: lightgrey; font: bold 8pt Verdana; color: black;" onclick="layoutEditor.closeInspector(this);" title="Revert changes">&nbsp;X </span>&nbsp\
<tr height="100%"><td colspan="2"><table width="100%">';

};

  var sizeOptions = "\n";
  var sizes = "8 10 12 15 20 25 30 40 50".split( / / );
  for ( var i=0 ; i<sizes.length ; i++ )
    sizeOptions += "<option value="+sizes[i]+"pt>"+sizes[i]+"\n";

  var resizeSelector = 
'<tr title="Element gravity on resize"><td>Resize:<td width="100%">\
<select name="align">\
<option value="0">\
<option value="4">Left\
<option value="1">Right\
<option value="8">Top\
<option value="2">Bottom\
<option value="12">Left/Top\
<option value="6">Left/Bottom\
<option value="9">Right/Top\
<option value="3">Right/Bottom\
</select>';

  var fieldInspector = '\
<tr title="ID of form element"><td>Id:<td width="100%"><input name="_id">\
<tr title="Name of form element"><td>Name:<td width="100%"><input name="name">\
<tr title="Tooltip for element"><td>Tooltip:<td width="100%"><input name="_title">\
<tr title="Initial value for element"><td>Text:<td width="100%"><input name="text">\
<tr title="Default value for element"><td>Default:<td width="100%"><input name="dflt">\
<tr title="Select Font"><td>Font:<td width="100%"><select name="font">\
<option value="Arial">Arial\
<option value="Georgia">Georgia\
<option value="Impact">Impact\
<option value="Tahoma">Tahoma\
<option value="Symbol">Symbol\
<option value="Verdana">Verdana\
</select>\
Size: <select name="size" title="Font Size">'+sizeOptions+'</select>\
'+resizeSelector+colorOK;

  var dataInspector = '\
<tr title="Element identifier"><td>Id:<td colspan="2" width="100%"><input name="_id">\
<tr title="Target id(s) for this form"><td>Target:<td width="100%"><input name="target">\
<tr title="Data source"><td>Source:<td width="100%"><input name="source">\
<tr title="Element Tooltip"><td>Tooltip:<td width="100%"><input name="_title">';


  layoutInspectors.innerHTML = '\
\
<form id="fieldInspector" '+stdInspector("Field")+fieldInspector+'\
</table></table></form>\
\
<form id="popupInspector" '+stdInspector("Popup")+fieldInspector+'\
<tr height="100%" title="SQL used to populate popup menu"><td valign="top" colspan="2"><textarea name="osql" cols="21" rows="10"></textarea></table></table></form>\
\
<form id="formInspector" '+stdInspector("Form")+dataInspector+'\
<tr title="Button Label"><td>Button:<td width="100%"><input name="button">\
<tr title="Button Alignment"><td>Align:<td width="100%"><select name="balign">\
<option value="">\
<option value="left">Left\
<option value="center">Center\
<option value="right">Right\
</select> <span title="Fetch target when loaded">Chain: <input name=chain value=chain type=checkbox style="background-color: #e0e0e0"></span>\
'+resizeSelector+colorOK+'\
<tr height="100%"><td valign="top" colspan="2"><textarea name="fsql" cols="22" rows="10" title="SQL used to populate this form"></textarea></table></table></form>\
\
<form id="tableInspector" '+stdInspector("Data Table")+dataInspector+'\
<tr title="Border for table"><td>Border:<td width="100%"><input name="border">\
'+resizeSelector+
'Fix:&nbsp;<input name="fix" style="width: 25" title="Columns at left to fix">\
'+colorOK+'\
<tr height="100%"><td valign="top" colspan="2"><textarea name="tsql" cols="22" rows="10" title="SQL used to fetch table data"></textarea></table></table></form>\
\
<form id="groupInspector" '+stdInspector("Group")+'\
<tr><td>Name:<td width="100%"><input name="name" title="Name of group">\
'+colorOK+'\
<tr height="100%"><td valign="top" colspan="2"><textarea name="gsql" cols="22" rows="10"></textarea></table></table></form>\
\
<form id="bodyInspector" '+stdInspector("Document")+'\
<tr title="DB access implementation"><td>Access:<td width="100%" align=right><input name="access">\
<tr title="Data source URL"><td>Source:<td width="100%"><input name="source">\
<tr title="On page load target(s)"><td>Target:<td width="100%"><input name="target">\
<tr title="Color Scheme"><td>Theme:<td width="100%"><select name="theme">\
<option value="">\
<option value="GreenScreen">GreenScreen\
<option value="Gothic">Gothic\
<option value="User1">User1\
<option value="User2">User2\
</select>'+colorOK+'</table></table></form>\
';
}

//**Start Encode**

DBLayout.prototype.closer = function() {
  this.form.closer.innerText = " ? ";
  this.form.onsubmit(1);
}

var editing, inspecting, saved, ts = new Date().getTime();

DBLayout.prototype.openInspector = function() {

  if ( !editing ) {
    if ( !layoutPalette.innerHTML || !document.getElementById( "_grid" ) || 0 )
      layoutEditor.writePalette();
  }

  var inspected = event ? event.srcElement : document.body;
  if ( !editing && inspected != document.body )
    return;

  while ( !inspected.inspector )
    inspected = inspected.parentNode;

  if ( !inspected )
    return;

  if ( layoutEditor.inspector )
    layoutEditor.inspector.style.display = "none";

  layoutInspectors.style.display = "block";
  layoutArea.className = "editing";

  var inspName = inspected.inspector;
  var inspector = layoutEditor.inspector = document.getElementById( inspName );
  if ( inspector ) {
    inspector.closer = inspector.children[0].children[0]
			.children[0].children[1].children[0];
    inspector.closer.innerText = " X ";

    var el = inspector.elements;
    for ( var i=0 ; i<el.length ; i++ ) {
    	el[i].onchange = layoutEditor.closer;
	if ( el[i].tagName == "TEXTAREA" )
	  if ( !inspector.id.match( /(popup)Inspector/ ) )
	    el[i].onfocus = layoutEditor.closer;
    }

    inspector.inspected = inspected;
    if ( editing ) {
      inspector.style.display = "block";
      inspector.elements[0].focus(); ///?
    }

    if ( inspected )
      layoutEditor[inspName.replace(/Inspector/,"Load")](inspector,inspected);
      inspector.onsubmit = layoutEditor[inspName.replace(/Inspector/,"Save")];
      inspecting = inspected;
      saved = inspected.outerHTML;

      if ( inspector.sized != ts && 1 ) {
        layoutEditor.obj = inspector;
        layoutEditor.width0 = inspector.clientWidth;
        layoutEditor.height0 = inspector.clientHeight;
//        layoutEditor.formResizer( 100, 150 );
        layoutEditor.formResizer( 350, 400 );
        layoutEditor.height0 = 0;
        layoutEditor.width0 = 0;
        layoutEditor.obj = null;
        inspector.sized = ts;
      }
  }
  else if ( editing && inspected.inspector != "bodyInspector" )
    alert( "Missing inspector: "+inspected.inspector );

  if ( !editing ) {	  
    editing = 1;
  }
}

DBLayout.prototype.setColor = function(style,color) {
  if ( color.value.match( /\./ ) ) {
    style.backgroundSize = "100%";
    style.backgroundColor = "";
    style.background = "url(/dbml/"+color.value+")";
  }
  else {
    style.background = "";
    style.backgroundColor = color.value;
  }
}

DBLayout.prototype.bodyLoad = function(inspector,inspected) {
  var paletteTable = layoutPalette.parentNode.parentNode.parentNode;
  paletteTable.style.display = "block";
  document.onmousedown = layoutEditor.startDrag;
  inspector.access.value = inspected.access || "";
  inspector.source.value = inspected.source || "";
  inspector.target.value = inspected.target || "";
  inspector.theme.value = inspected.className;
  inspector.color.value = inspected.style.backgroundColor;
}

DBLayout.prototype.bodySave = function(f) {
with ( this ) {
  inspected.access = access.value;
  inspected.source = source.value;
  inspected.target = target.value;
  inspected.className = theme.value;
  layoutEditor.setColor(inspected.style,color);
  if(!f) this.style.display = "none";
  return layoutEditor.hasChanged();
} }

DBLayout.prototype.closeInspector = function(i) {
with ( layoutEditor.inspector ) {
  if ( inspected != document.body &&
	inspected.outerHTML != saved && 
	!confirm( "Revert changes?" ) )
    return;
  i.parentNode.parentNode.parentNode
   .parentNode.parentNode.style.display = "none";
  if ( inspected != document.body )
    inspected.outerHTML = saved;
} }

DBLayout.prototype.fieldLoad = function(inspector,inspected) {
  inspector._id.value = inspected.id;
  if ( inspected.tagName == "INPUT" ) {
    inspector.name.value = inspected.name;
    inspector.text.value = inspected.value;
    inspector.dflt.value = inspected.dflt || "";
    inspector.name.parentNode.parentNode.style.display = "block";
  }
  else {
    inspector.text.value = inspected.innerHTML =
	inspected._text || inspected.innerHTML;
    inspector.name.parentNode.parentNode.style.display = "none";
  }
  inspector.font.value = inspected.currentStyle.fontFamily;
  inspector.size.value = inspected.currentStyle.fontSize;
  inspector.color.value = inspected.currentStyle.color;
  inspector.align.value = inspected.alignment || "";
  inspector._title.value = inspected.title || "";
}

DBLayout.prototype.fieldSave = function(f) {
with ( this ) {
  if ( !this.popup )
    inspected.id = this._id.value;
  if ( inspected.tagName == "INPUT" ) {
    var parent = inspected.parentNode;
    parent.innerHTML = parent.innerHTML
	.replace( /name=\w+/, "name="+this.name.value );
    this.inspected = parent.childNodes[0];
    inspected.value = this.text.value;
    inspected.dflt = this.dflt.value;
  }
  else {
    inspected.innerHTML = inspected._text = text.value;
    var ftab  = inspected.parentNode && 
		inspected.parentNode.parentNode.parentNode.parentNode;
    ftab.className = text.value ? "not_invisible" : "invisible";
  }  

  inspected.style.fontFamily = font.value;
  inspected.style.fontSize = size.value;
  inspected.style.color = color.value;
  inspected.alignment = align.value;
  if ( _title.value || inspected.title )
    inspected.title = _title.value;

  if(!f) this.style.display = "none";
  return layoutEditor.hasChanged();
}
}

DBLayout.prototype.popupLoad = function(inspector,inspected) {
  layoutEditor.fieldLoad(inspector,inspected);
  var popup = inspector.popup = inspected
	.parentNode.parentNode
	.children[1].children[0];
  inspector._id.value = popup.id || "";
  inspector.name.value = popup.name || "";
  inspector.osql.value = popup.optionAction || "-- Enter SQL here";
  inspector.name.parentNode.parentNode.style.display = "block";
}

DBLayout.prototype.popupSave = function(f) {
  this.popup.outerHTML = '<select '+
	(this._id.value?'id="'+this._id.value+'" ':'')+
	'name="'+this.name.value+'" '+
	'optionAction="'+this.osql.value+'"></select>';
  this.onsubmit = layoutEditor.fieldSave;
  if (!f) return this.onsubmit();
  return layoutEditor.hasChanged();
}

function doAlign() {
  var buttonTD = formInspector.inspected.children[0].children[0].children[0].children[0];
  buttonTD.align = formInspector.balign.value;
}

DBLayout.prototype.formLoad = function(inspector,inspected) {
  inspector._id.value = inspected.id;
  inspector.target.value = inspected.target;
  inspector.source.value = inspected.source || "";
  inspector._title.value = inspected._title || "";
  inspector.button.value = inspected.button.value != "Submit Query" &&
	inspected.button.value || "";
  inspector.align.value = inspected.alignment || "";
  inspector.color.value = inspected.currentStyle.backgroundColor;
  inspector.fsql.value = inspected.formAction || "-- Enter SQL here";
  inspector.fsql.setsql && inspector.fsql.setsql();
  inspector.chain.checked = inspected._chain;
  inspector.balign.onchange = doAlign;
}

DBLayout.prototype.formSave = function(f) {
with ( this ) {
  inspected.id = _id.value;
  inspected.target = target.value;
  inspected.source = source.value;

  inspected.button.value = button.value || "";
  if ( !button.value )
    inspected.button.style.display = "none";
  else
    inspected.button.style.display = "block";
  if ( _title.value || inspected.title )
    inspected.title = _title.value;

  layoutEditor.setColor(inspected.style,color);
  inspected.alignment = align.value;
  inspected.alignment = align.value;
  inspected.formAction = (fsql.value=="-- Enter SQL here"?"":fsql.value);
  inspected._chain = chain.checked;
  if(!f) this.style.display = "none";
  return layoutEditor.hasChanged();
}
}

//DBLayout.prototype.doAlign = function(sel) {
DBLayout.prototype.tableLoad = function(inspector,inspected) {
  inspector._id.value = inspected.id;
  inspector.target.value = inspected.target || "";
  inspector.source.value = inspected.source || "";
  inspector._title.value = inspected.title || "";
  inspector.border.value = inspected.style.border || "";
  inspector.align.value = inspected.alignment || "";
  inspector.color.value = inspected.currentStyle.backgroundColor;
  inspector.tsql.value = inspected.tableAction || "-- Enter SQL here";
  inspector.tsql.setsql && inspector.tsql.setsql();
  inspector.fix.value = inspected.fixcols || "";
}

DBLayout.prototype.tableSave = function(f) {
with ( this ) {
  inspected.id = _id.value;
  inspected.target = target.value;
  inspected.source = source.value;
  inspected.style.border = border.value;
  inspected.tableAction = tsql.value;
  layoutEditor.setColor(inspected.style,color);
  inspected.alignment = align.value;
  inspected.fixcols = fix.value || "";
  if ( _title.value || inspected.title )
    inspected.title = _title.value;

  dbtable.updateAlignment( inspected, document.body.clientWidth, document.body.clientHeight );

  if(!f) this.style.display = "none";
  return layoutEditor.hasChanged();
}
}

DBLayout.prototype.groupLoad = function(inspector,inspected) {
  inspector.gsql.value = inspected.groupAction || "";
  inspector.gsql.setsql && inspector.gsql.setsql();
  inspector.color.value = inspected.style.backgroundColor;
  inspector.name.value = inspected.name;
}

DBLayout.prototype.groupSave = function(f) {
with ( this ) {    
  if ( name.value ) {
    var parent = inspected.parentNode;
    parent.innerHTML = parent.innerHTML
	.replace( /name=\w+/, "name="+name.value ).replace(/\bCHECKED\b /,"");
    this.inspected = parent.childNodes[0];
  }
  inspected.name = name.value;
  inspected.groupAction = gsql.value;
  inspected.style.backgroundColor = color.value;
  if(!f) this.style.display = "none";
  return layoutEditor.hasChanged();
}
}

var copied, displaced;

function dogrid(v) {
  var roundby = (document.getElementById("_grid")||{value:5}).value || 1;
  return Math.floor( v / roundby ) * roundby;
}

function depix(p) {
  return (""+p||"0").match(/\d+/)[0]*1;
}

DBLayout.prototype.deleteObject = function() {
  with ( layoutEditor ) {
    var isCell = event.srcElement.tagName == "INPUT" ||
		event.srcElement.tagName == "TEXTAREA", 
	lastc0s = lastObj && lastObj.children && lastObj.children[0].style;
    if ( !editing || isCell )
	return;

    if ( (event.keyCode == 8 || event.keyCode == 46 ) && 
	lastObj && !inspecting ) { 
      for ( var i=0 ; i<tables.length ; i++ )
        if ( tables[i] == lastObj.children[0] )
	  tables[i] = null;
      lastObj.outerHTML = "";
    }
    else if ( event.keyCode == 37 ) // left
      if ( event.shiftKey )
	lastc0s.width = lastObj.offsetWidth-1;
      else
	lastObj.style.left = depix(lastObj.style.left)-1;	
    else if ( event.keyCode == 38 ) // up
      if ( event.shiftKey )
	lastc0s.height = lastObj.offsetHeight-1;
      else
	lastObj.style.top = depix(lastObj.style.top)-1;
    else if ( event.keyCode == 39 ) // right
      if ( event.shiftKey )
	lastc0s.width = lastObj.offsetWidth+1;
      else
	lastObj.style.left = depix(lastObj.style.left)+1;
    else if ( event.keyCode == 40 ) // down
      if ( event.shiftKey )
	lastc0s.height = lastObj.offsetHeight+1;
      else
	lastObj.style.top = depix(lastObj.style.top)+1;
    else if ( event.ctrlKey )
      if ( event.keyCode == 67 ) { // copy
	if ( lastObj != document.body )
	  copied = lastObj;
        displaced = 0;
      }
      else if ( event.keyCode == 86 && copied ) { // paste
	var copy = document.createElement( "span" );
	displaced += 10;
	copy.style.left = depix(copied.style.left)+displaced;
	copy.style.top = depix(copied.style.top)+displaced;
	copy.innerHTML = copied.innerHTML;
	copy.style.position = "absolute";
	copy.dragState = "move";
	event.cancelBubble = true;
	layoutArea.appendChild(copy);
      }
    else
	return;
  }
}

DBLayout.prototype.targetLoad = function(form) {
  dbml.populateTargets( form );
  return false;  
}

DBLayout.prototype.startDrag = function() {
dbml.log( "start " );
with ( layoutEditor ) {
  var src = layoutEditor.srcElement = window.event.srcElement;
  layoutEditor.moved = -1;

  if ( src.tagName == "INPUT" && src.inspector != "fieldInspector" &&
	src.inspector != "groupInspector" || src.tagName == "TEXTAREA" )
    return false;

  while ( !src.dragState ) {
    src = src.parentNode;
    if ( !src || src == document.body )
      return false;
  }

  if ( src.className == "windowBar" )
    src = src.parentNode.parentNode.parentNode;

  layoutEditor.picked = src.dragState == "pick";
  if ( picked ) {
    layoutEditor.obj = document.createElement("SPAN");

    obj.style.position = "absolute";
    obj.innerHTML = src.innerHTML;
    obj.dragState = "move";

    layoutArea.appendChild(obj);
  }
  else
   layoutEditor.obj = src;

  layoutEditor.lastObj = obj;
  if ( src.children[0].loaded )
    return false;

  layoutEditor.offsetX = event.clientX;
  layoutEditor.offsetY = event.clientY;

  do {
    layoutEditor.offsetX -= src.offsetLeft;
    layoutEditor.offsetY -= src.offsetTop;
    src = src.offsetParent;
  } while ( src != document.body &&
	(picked || src.style.position != "absolute" ) );

  if ( event.shiftKey || !event.ctrlKey && !picked && ( //!obj.contained && (
	obj.offsetWidth - (offsetX - obj.offsetParent.offsetLeft) < 20 || 
	obj.offsetHeight - (offsetY - obj.offsetParent.offsetTop) < 10 ) ) {

    layoutEditor.offsetX = event.clientX - obj.offsetWidth;
    layoutEditor.offsetY = event.clientY - obj.offsetHeight;

    if ( obj.children[0].tagName == "FORM" )
        ;//      layoutEditor.offsetY += 19;
    if ( obj.id.match( "Inspector$" ) )
      layoutEditor.resizer = formResizer;
    else if ( obj.children[0].resizer )
      layoutEditor.resizer = layoutEditor[obj.children[0].resizer];
    else
      layoutEditor.resizer = defaultResizer;

    layoutEditor.obj.style.cursor = "SE-resize";
  }
  else {
     if ( !picked )
	layoutEditor.obj.style.cursor = "move";
    layoutEditor.resizer = null;
  }
      inspecting = null;

  if ( !obj.id.match( "Inspector$" ) ) {
    obj.style.border = "1px inset gray";
    obj.ondblclick = layoutEditor.openInspector;
  }

  document.onmousemove = layoutEditor.performDrag;
  document.onmouseup = layoutEditor.performDrop;

  layoutEditor.top0 = obj.style.top;
  layoutEditor.left0 = obj.style.left;

  return performDrag();
}
}

DBLayout.prototype.fieldResizer = function(width,height) {
with ( layoutEditor ) {
  if ( layoutEditor.width0 )
    srcElement.style.width = Math.max( 20, srcElement.offsetWidth+width-width0 );
  layoutEditor.width0  = width;
  layoutEditor.height0 = height;
}
}

DBLayout.prototype.formResizer = function(width,height) {
with ( layoutEditor ) {
  if ( layoutEditor.width0 ) {
    var elements = obj.elements;
    for ( var i=0 ; i<elements.length ; i++ ) {
     	var input = elements[i];
	if ( !input.type.match( /submit|checkbox/ ) &&
		input.name != "size" && input.name != "fix" )
          input.style.width = Math.max( 20, input.offsetWidth+width-width0 );
	if ( input.tagName == "TEXTAREA" )
          input.style.height= Math.max( 20,input.offsetHeight+height-height0 );
    }
  }

  layoutEditor.width0  = width;
  layoutEditor.height0 = height;
}
}

DBLayout.prototype.defaultResizer = function(width,height) {
with ( layoutEditor ) {
     obj.children[0].style.width  = Math.max( 20, width );
     obj.children[0].style.height = Math.max( 20, height );
}
}

DBLayout.prototype.performDrag = function() {
dbml.log( "move " );
with ( layoutEditor ) {
 moved++;
 if ( obj ) {
   var x = event.clientX;
   var y = event.clientY;
   var dx = x - offsetX - depix(obj.style.left);
   var dy = y - offsetY - depix(obj.style.top);

   if ( dx || dy ) //Math.sqrt( dx*dx, dy*dy ) > 2 )
   if ( resizer )
     layoutEditor.resizer( dogrid(x - offsetX), dogrid(y - offsetY) );
   else {
     obj.style.left = dogrid(x - offsetX);
     obj.style.top  = dogrid(y - offsetY);
   }

   if ( obj.className == "dbmlInspector" )
	return false;

   layoutEditor.form = null;
   var forms = document.forms;

   if ( !obj.contained )
   for ( var i=1; i<forms.length ; i++ ) {
     var f = forms[i].parentNode;
     if ( f != obj && forms[i].inspector == "formInspector" &&
	  x > f.offsetLeft && x < f.offsetLeft + f.offsetWidth &&
          y > f.offsetTop  && y < f.offsetTop + f.offsetHeight ) {
       f.style.border = "2px inset gray";
       layoutEditor.form = f;
     }
     else
       f.style.border = "";
   }
 }

 event.cancelBubble = true;
 return false;
}
}

DBLayout.prototype.performDrop = function() {
dbml.log(  "drop " );
with ( layoutEditor ) {
  if ( !moved && picked ) {
    obj.outerHTML = "";
    return reset();
  }    

  if ( obj.children[0].tagName == "FORM" ) {
    if ( !obj.sized && 0 ) {
	obj.style.width = 100;
	obj.style.height = 100;
	obj.sized = 1;
    }
  }
  else if ( form && !obj.contained ) {
   var o = document.createElement("SPAN");

   o.innerHTML = obj.innerHTML;
   o.style.position = "absolute";
   o.style.left = obj.offsetLeft - form.offsetLeft;
   o.style.top = obj.offsetTop - form.offsetTop;
   o.dragState = "move";
   o.contained = 1;

   form.children[0].appendChild( o );
   form.style.border = "";
   obj.outerHTML = "";
   obj = o;
  }

  if ( obj.className != "dbmlInspector" )
    dbtable.updateAlignment( obj.children[0] );

  var o = obj.children[0];
  if ( o && o.inspector == "tableInspector" && !o.id ) {
	tables[tables.length] = o;
	o.id = "table"+tables.length;
  }
  else if ( o && o.inspector == "formInspector" && !o.target ) {
    if ( document.getElementById( "table"+tables.length ) )
	o.target = "table"+tables.length;
    o.id = "form"+(document.forms.length-8);
  }

  layoutEditor.hasChanged();
  return reset();
}
}

DBLayout.prototype.reset = function() {
  layoutEditor.obj.style.cursor = "auto";
  layoutEditor.obj.style.border = "";
  document.onmousemove = null;
  document.onmouseup = null;
  layoutEditor.width0 = null;
  layoutEditor.form = null;
  layoutEditor.obj = null;
  return false;
}  

DBLayout.prototype.recoverAlignments = function(t) {   

  if ( location.href.match( "start.html|time=" ) ) {
    layoutPalette.parentNode.parentNode.parentNode.style.display = "block";
    document.onmousedown = this.startDrag;
  }

  var laidout = layoutArea.childNodes;
  for ( var i=0 ; laidout&&i<laidout.length ; i++ ) {
    var obj = laidout[i].children;
    if ( obj && obj[0].alignment )
      dbtable.updateAlignment( obj[0], document.body.clientWidth0, document.body.clientHeight0 );
  }

  if ( document.body.outerWidth0 > 0 && document.body.outerHeight0 > 0 )
    window.resizeTo( document.body.outerWidth0, document.body.outerHeight0 );

    layoutEditor.writeInspectors();
}

// singleton
new DBLayout();

if ( document.location.href.match( /\/new\.dbml/ ) )
  window.layoutEditor.openInspector();

