/*
 * $Id: //depot/jhttpd/docs/dbml/dbml.js#13 $
 *
 * COPYRIGHT(C) 2003 Coldwave Programs Ltd. ALL RIGHTS RESERVED
 * for an updated copy of this file please go to www.dbajax.com
 *
 * By downloading this software you have agreed to the following terms:
 * This software is available free for individual use or evaluation only.
 * If you wish to incorporate ANY of the code in this release into
 * a product or production application a source license is required.
 * This software may not be redistributed whole or in part.
 *
 * THIS SOFTWARE IS PROVIDED BY COLDWAVE PROGRAMS LTD "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL COLDWAVE PROGRAMS LTD OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

dbml_js = "$Id: //depot/jhttpd/docs/dbml/dbml.js#13 $";

var objectAttributes = [];

function ga(x,k) {
  var v = x && x.getAttribute && x.getAttribute(k);
  if ( v && (typeof v) == "string" && v.match( /^@/ ) )
    v = objectAttributes[v.substring(1)];
  return v;
}

function sa(x,k,v) {
  if ( (typeof v) == "object" ) {
   x.setAttribute(k,"@"+objectAttributes.length);
   objectAttributes[objectAttributes.length] = v;
  }
  else
    x.setAttribute&&x.setAttribute(k,v);
  return v;
}


function DBML() { 
  this.ts = (new Date()).getTime();
  this.queue = [];
}

DBML.prototype.viewSource = function() {
  location.href = "view-source:"+location.href;
}

DBML.prototype.populateTargets = function( form ) {
  var target = dbml.queue[0];
  if ( !form && target ) {
    dbml.queue = [];
    var req = ga( target, "req" ); //
    if ( req ) {
      req.onreadystatechange = null;
      req.abort();
    }
  }

  form = form || this;

  if ( form == window )
    sa( form = document.body, "search",
	(document.location.search||"").replace( /^\?/, "" ) );
  else
    sa( form, "search", dbml.formQueryString( form ) );

  var target = form.target||ga(form,"target");
  if ( target.match( /^(.+\.\w+)(\?.*)?$/ ) ) {
    window.open( (window._root||"")+target+(target.match(/\?/)?"&":"?")+ga(form,"search") );
    return false;
  }

  if ( 1 || !ga( form, "targets" ) ) {
    var tnames = target.split( /\s*,\s*/ );

    var targets = [];
    for( var t=0 ; target && t<tnames.length ; t++ )
	if ( !(targets[t] = document.getElementById(tnames[t])) ) {
	  alert( "Could not find target named: "+tnames[t]+
		" for form: "+form.id ); //form.outerHTML );
	  return false;
	}
    sa( form, "targets", targets );
  }

  var targets = ga( form, "targets" ), len0 = dbml.queue.length;
  for( var t=0 ; t<targets.length ; t++ )
    sa( dbml.queue[dbml.queue.length] = targets[t], "from", form );

  if ( targets.length )
;//    document.body.style.cursor = "wait"; /////

  if ( window.autologout )
    clearTimeout( window.autologout );

  if ( !len0 )
    setTimeout( "dbml.scheduleRequests();", 5 );
  return false;
}

DBML.prototype.scheduleRequests = function() {
  var target = this.queue[0];
//alert("SCHED: "+ga( target, "req" ));

  if ( target ) {//&& !ga( target, "req" )) {
    while ( this.queue[1] == target )
      this.queue = this.queue.slice( 1 );

    var search = ga( ga( target, "from" ), "search" );
    var text = ga( target, "_text" );
    if ( text ) {
      target.innerHTML = this.substituteParameters( text, search );
      this.queue = this.queue.slice( 1 );
      return this.scheduleRequests();
    }

//  if ( !ga( target, "batch" ) )
      this.prepareTarget( target );

    var source = sa( target, "source", 
	ga( target, "source" ) ||
        ga( ga( target, "from" ), "source" ) ||
        ga( document.body, "source" ) );
    if ( !source )
      return alert( "No source set for target "+target.id+" "+target.innerHTML );
//    if ( !document.location.href.match( /:\d+\/jsql\// ) )
//	source = document.body.defaultSource;

    sa( target, "sql", this.substituteParameters( ga( target, "batch" ),
				 search ) );
    
    var sql = escape( ga( target, "sql" ) ).replace( /\+/g, "%2B" );
    sa( target, "url", source+(source.match(/(\?)/)?"&":"?")+search+
	"&fixcols="+(target.fixcols||0)+
	"&_sql="+ sql + "&_ts="+this.ts++ );

//alert(sql);

    var mat = source.match( /^([^:]*):(\.*)$/ );
    if ( !mat )
	mat = ["", "http", source];
    var adaptorName = mat[1]+"Request";
    var dataAccess = window[adaptorName];
    if ( !dataAccess ) {
	alert( "No adaptor found named: "+adaptorName );
	return false;
    }

//alert(mat[2]);
    var da = new dataAccess( mat[2] );
    sa( target, "request", da );
    da.start(target);

    if ( target.className == "popup" ) {
      target.popup = open( "", target.id, target.features );
      target.popup.document.write( "<html><head>"+
	"<title>"+target.id+"</title>\n"+dbmlStyle+
////	"<link rel=stylesheet href='/dbml/dbml.css'>\n"+
//	"<script src='dbml.js'></script>\n"+
	"</head><body style='margin: 0'>\n" );
    }
  }
}

DBML.prototype.formQueryString = function( form ) {
  var elements = form.elements||ga(form,"selection")||form.all;
  var parameters = "";

  for( var i=1-1 ; elements&&i<elements.length ; i++ ) {
    var el = i<0 ? form : elements[i];
    var val = el.value || ga( el, "value" );
    if ( val == null || !val.match( /\S/ ) )
      val = el.dflt;

    if ( el.tagName == "TEXTAREA" ) {
	var range = document.selection.createRange();
	if ( range.parentNode() == el && range.text )
	  val = range.text;
    }
    else if ( el.tagName == "SELECT" && el.multiple ) {
      for ( var o=0 ; o<el.options.length ; o++ )
	if ( el.options[o].selected )
	  parameters += (parameters&&"&")+el.name+
	    "="+escape(el.options[o].value||el.options[0].text);
      continue;
    }
    else if ( el.tagName == "INPUT" && el.type.match( /checkbox|radio/i ) )
      if ( !el.checked )
        continue;

    var name = ga( el, "name" );
    if ( name )
      parameters += (parameters&&"&")+name+"="+escape(""+val)
	.replace( /\+/g, "%2b" ).replace( /%u2212/g, "-" );
  }

  return parameters;
}

DBML.prototype.substituteParameters = function( sql, search ) {
  var params = search.replace( /^\?/, "" ).split( "&" );

  for ( var p = params[0]?0:1 ; p<params.length ; p++ ) {
    var arr = params[p].match( /([^=]+)=?(.*)/ );
    var name = arr[1];
    var value = unescape( (arr[2]||"").replace(/\+/g, " ") ) /////
	.replace(/'/g, "''" );

    var re = new RegExp( "(\\$\\$"+name+"\\b('|\")?)", "g" );
    sql != (sql = sql.replace( re, "$2, $2"+value+"$1" ) ) ||
    (sql = sql.replace( new RegExp( "(\\$"+name+"\\b)", "g" ),
    value+"$$$1" ) );
  }

  sql = sql.replace( /\$?\$\$\w+/g, "" );

//  if ( !search )
//    return sql;

  var m;
  while ( m = sql.match( /\$\w+\b/ ) )
	sql = sql.replace( new RegExp( "\\"+m[0], "g" ) ,
		prompt( "Please provide a value for parameter "+m[0], "" ) );

  return sql;
}

DBML.prototype.prepareTarget = function( target ) {
  var all = target.all||this.getAll(target);
  var actives = sa( target, "actives", [] );
  var batch = "";

  for( var i=-1 ; i<all.length ; i++ ) {
    var elm = i<0 ? target : all[i];
    var sql = ga( elm, "formAction" ) ||
	ga( elm, "innerAction"  ) || ga( elm, "tableAction" ) ||
	ga( elm, "columnAction" ) || ga( elm, "optionAction") || 
	ga( elm, "groupAction"  ) || ga( elm, "valueAction" ) ||
	ga( elm, "updateAction" ) || ga( elm, "nullAction"  );

    if ( sql ) {
      if ( !ga( elm, "nullAction" ) )
        actives[actives.length] = elm;

      if ( !ga( elm, "columnAction" ) )
        batch += sql+" ";
      if ( ga( elm, "optionAction" ) && ga( elm, "valueAction" ) )
	batch += ga( elm, "valueAction" )+" ";
    }

    if ( !elm.onsubmit && elm.target )
      elm.onsubmit = this.populateTargets;

    if ( elm.tableAction )
      elm.innerHTML = "Fetching...";
  }

  sa( target, "batch", batch );
}

DBML.prototype.fetchElements = function() {
  var target = dbml.queue[0];
  var req = ga( target, "request" );
  var xml = req && req.xml();

  if ( xml == null  ) return;

  dbml.queue = dbml.queue.slice(1);
  tabs = (""+xml).split( /\s*<p><\/p>\s*/g ).slice(1,-1);

    var rows, cols, set = -1;

    var actives = ga( target, "actives" );
    for( var a=0 ; a<actives.length ; a++ ) {
      var active = actives[a];

      if ( ga( active, "columnAction") ) {
	  if ( !rows )
	    return alert( "columnsAction used before query:\n"+active.outerHTML );
	  for ( var c=0 ; c<cols.length ; c++ )
	    if ( ga( active, "columnAction" ) == cols[c].innerText )
	      active.innerHTML = rows.length ?
		rows[0].cells[c].innerText : "";

	  continue;
      }

      if ( ga( active, "formAction" ) && tabs[++set] ) {
	  dbmlScratch.innerHTML = tabs[set];
	  var hdrs = dbmlScratch.getElementsByTagName( "THEAD" )[0]
				.getElementsByTagName( "TH" );
      	  var cells = (dbmlScratch.getElementsByTagName( "TBODY" )[0]
				.getElementsByTagName( "TR" )[0]
					||{}).childNodes;

	  if ( hdrs[0].innerText && hdrs[0].innerText.match( /Fetch Error/ ) )
	    alert( "SQL Error in form '"+active.id+"':\n"+cells[0].innerText );

	  for ( var i=0 ; i<hdrs.length ; i++ ) {
	    var name = hdrs[i].innerText || hdrs[i].innerHTML;
	    name = name.replace( /\s+/g, "" );
	    if ( active[name] )
	      active[name].value = cells ?
		cells[i].innerHTML.replace( /&nbsp;/g," " ) : "";
	  }

	  if ( active._chain == "true" )
	    dbml.populateTargets( active );
	  continue;
      }


      if ( ga( active, "tableAction" ) ) {
	active.selection = null;	
	var html = "";

	var sets = Math.min( active.sets||1000, tabs.length-set-1 );
	for ( var s=0 ; s<sets ; s++ ) {
	  var tab = tabs[++set];

	  // remove trailing non-breaking space
	  tab = tab.replace( /([^>])(&nbsp;)+</g, "$1<" );

	  if ( active.flip ) {
	    dbmlScratch.innerHTML = tab;
	    cols = dbmlScratch.getElementsByTagName( "THEAD" )[0]
				.getElementsByTagName( "TH" );
	    rows = dbmlScratch.getElementsByTagName( "TBODY" )[0]
				.getElementsByTagName( "TR" );
	    tab = "<table>";

	    for ( var c=0 ; c<cols.length ; c++ ) {
	      tab += (c==0 ? "<thead>" : c==1 ? "<tbody>" : "")+"<tr>";

	      if ( !active.noheader )
		tab += cols[c].outerHTML
		  .replace( />/, " class=hfix align=left>" );

	      for ( var r=0 ; r<rows.length ; r++ )
		tab += (rows[r].children[c]||{}).outerHTML;
	    }

	    tab += "</table>";
	  }

/*
	  // patch in fixed columns
	  var restr = "(<tr[^>]*>\\s*<t[hd][^>]*";
          for( var c=0 ; c<active.fixcols ; c++ ) {
	    var re = new RegExp( restr+")>", "gi" );
	    tab = tab.replace( re, "$1 class=hfix>" );
	    restr += ">[^<]*<(/t[hd]>\\s*<)?t[hd][^>]*";
          }
	  if ( active.fixcols )
	    tab = tab.replace( /class="[^"]*" (class=)/g, "$1" );
*/

	  if ( active.tagName == "SPAN" )
	    active.tableattr = (active.tableattr||"")+" align=left";

	  html += (html&&"<p></p>")+tab.replace( />/, (active.tableattr||"")+
		" cellspacing=0 class=dbtable style='table-layoutt:fixed'>" );
	}
/*
	var targets = ga( active, "targets" );
        for ( var t=0; targets&&t<targets.length ; t++ )
	  targets[t].style.display = "none";
*/
/*
	if ( active.parent )
	  active.document.write( "<html><body><script src='/dbml/dbml.js'></script>"+html );
	else
*/
	active.innerHTML = html;
	active.loaded = 1;
        if ( active.pagerows )
  	  dbtable.changePage(null,-9999,active);
	active.scrollLeft = 0;
	active.scrollTop = 0;

	var scroller = (active.currentStyle||active.style).overflow == "auto" ?
			active : active.document.body;

/*
	var s =	active.getElementsByTagName( "TBODY" );
	s[0].style.left = "100";

	if ( !target.popup )
	  setScroller( active, scroller );

	if ( active.target )
	  active.onclick = dbml.rowClick;
*/
	  active.onmousedown = dbml.rowClick;
 	continue;
      }

      if ( ++set == tabs.length )
	break;

      dbmlScratch.innerHTML = tabs[set];
      cols = dbmlScratch.getElementsByTagName( "TH" );
      rows = dbmlScratch.getElementsByTagName( "TBODY" )[0];
      if ( rows ) rows = rows.getElementsByTagName( "TR" );

      if ( ga( active, "groupAction" ) ) {
	var html = "<table class=groupHTab>", save = active.outerHTML;

        for ( var r=0 ; r<rows.length ; r++ ) {
	  var row = rows[r].getElementsByTagName( "TD" );
	  html += "<tr><td>"+(active.saveHTML||active.outerHTML).replace( /""/,
		'"'+row[0].innerText.replace( /\t/g, " " )+'"' )
		+(row[1]||row[0]).innerText;
	}

	active.outerHTML = html+"</table>";
        active.saveHTML = save;
      }
      else if ( ga( active, "optionAction" ) ) {
        for ( var r=active.options.length=0 ; r<rows.length ; r++ ) {
	  var row = rows[r].getElementsByTagName( "TD" );
          active.options[r] = new Option( 
	      (""+row[0].innerHTML).replace( /\t/g, " " )
		.replace( /&nbsp;/g, " " ), 
	      (row[1]||row[0]).innerHTML);
	}

	if ( !active.onchange && active.target )
	  active.onchange = dbml.populateTargets;

	if ( ga( active, "valueAction" ) ) {
	  dbmlScratch.innerHTML = tabs[++set];
	  active.value = dbmlScratch.getElementsByTagName( "TBODY" )[0]
			 	    .getElementsByTagName( "TR" )[0]
			    	    .getElementsByTagName( "TD" )[0].innerText;
	}
      }
      else if ( rows ) {
        var val = "";

        for ( var r=0 ; r<rows.length ; r++ ) {
	  var row = rows[r].getElementsByTagName( "TD" );
	  val += (r?(active.delim||""):"")+row[0].innerText;
	}

        if ( ga( active, "innerAction" ) )
          active.innerHTML = val;
        else if ( ga( active, "valueAction" ) )
          active.value = val;
      }

      active.style.display = "";
    }

  dbml.reveal(target);

  if ( target.popup ) {
    var doc = target.popup.document;
    doc.write( target.outerHTML );
//    setScroller( doc.body.children[0], target.popup.document.body );
    doc.body.children[0].className = "";
  }
  else
    target.style.display = "";

  if ( dbml.queue.length )
    setTimeout( "dbml.scheduleRequests();", 1 );
  else {
    document.body.style.cursor = "auto";
    window.autologout = setTimeout( "disconnect()", 5*60*1000 );
  }
}

DBML.prototype.reveal = function(d) {
  if ( d.filters && d.filters[0] ) {
    d.filters[0].apply();
    d.style.visibility = "visible";
    d.filters[0].play();
  }
}

DBML.prototype.setScroller = function( active, owner ) {
  var tabs = active.getElementsByTagName( "TABLE" );

  for ( var t=0 ; t<tabs.length ; t++ ) {
    var tab = tabs[t];
    var rows = tab.children[0].children;
//    rows[0].sp = scrollParent( tab ) || owner;
//    rows[0].className = "vfix";
    tab.className = "dbtable";

/*
  var t = [];
  var p = tab;
  for ( var i=0 ; p.offsetParent ; p=p.offsetParent ) {
    p.setExpression( "realOffsetTop", "b(this.offsetTop)"+
	(p.offsetParent.offsetParent ? "+this.offsetParent.realOffsetTop" : "") );
  }
*/
  }

}

DBML.prototype.rowClick = function(e) {
  var cell = e ? e.target : event.srcElement;
  if ( !cell.tagName.match( /TD|TH/ ) )
    return true;

  var row = cell.parentNode;
  var tab = row.parentNode.parentNode;
  var cells = row.childNodes;
  var hdrs = tab.childNodes[0].childNodes[0].childNodes;
  var hack = hdrs.length!=cells.length; //??

  if ( cells == hdrs )
    return dbtable.headerClick(e);

  if ( !this.target && !ga(this,"target") )
    return true;

  for ( var i=0 ; i<cells.length ; i++ ) {
    var c = cells[i];
    sa( c, "name", hdrs[hack?i*2+1:i].innerText );
    sa( c, "value", c.innerText || c.innerHTML );
  }

  var sel = ga( this, "selection" );
  if ( sel && sel[0] && sel[0].parentNode )
    sel[0].parentNode.className = "";
  sa( this, "selection", cells );
  cell.parentNode.className = "selected";

  if ( this.action )
    open( this.action+"?"+formQueryString(this), this.target, this.feautures );
  else
    return dbml.populateTargets( this );
}

DBML.prototype.getAll = function( target ) {
  return [];
}

if ( document.location.href.match( /[?&]_?debug=1/ ) )
  document.write( '<textarea id=logger cols=132 rows=40>...</textarea><br>' );
else if ( document.getElementById("logger") )
  document.all.logger.outerHTML = "";

var i = 0;
DBML.prototype.log = function(x) {
  if ( document.getElementById("logger") )
    logger.value += x+". ";
  return x;
}

dbml = new DBML();

//alert(window.onload);
if ( !window.onload && ga( document.body, "target" ) ) //alert("KJ");
  window.onload = dbml.populateTargets;

//window.onlaod = function() {
  var forms = document.forms;
  var all = document.all;

  for ( var f=0 ; all && f<forms.length ; f++ )
    if ( forms[i] && !forms[f].action && !forms[f].onsubmit &&
	all[(""+forms[f].target).split(",")[0]] )
      forms[f].onsubmit = dbml.populateTargets;

  var e = document.body.getElementsByTagName( "SQLTAB" );
  for( var i=0; i<e.length ; i++ ) {
    alert(e[i].outerHTML);
    e[i].outerHTML = "<span "+e[i].innerText.match( "<SQLTAB([^>]*)" )[1]+
//	+" tableAction=\""+e[i].innerText.replace( /\"/g, "\\"" )
	+"\"><span>";
  }
//}
if ( !ga( document.body, "dbml_js" ) ) {
  sa( document.body, "dbml_js", 1 );
  document.write( '\
\
<script src="/dbml/dbaccess.js"></script>\
<script src="/dbml/dbtable.js"></script>\
<div id="dbmlScratch" class=hidden></div>\
\
' );
////<link rel="stylesheet" href="/dbml/dbml.css">\
}

