
/*
 * $Id: //depot/jhttpd/docs/jsqldocs/completion.js#30 $
 *
 * COPYRIGHT(C) 2010 Coldwave Programs Ltd. ALL RIGHTS RESERVED
 * for an updated copy of this file please go to www.dbexplorer.com
 *
 * By downloading this software you have agreed to the following terms:
 * This software is available free for individual use or evaluation only.
 * If you wish to incorporate ANY of the code in this release into
 * a product or production application a source license is required.
 * This software may not be redistributed whole or in part.
 *
 * THIS SOFTWARE IS PROVIDED BY COLDWAVE PROGRAMS LTD "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL COLDWAVE PROGRAMS LTD OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

/*********** table name completion **************/

if ( !hover )
  document.write( "<div id=hover style='position: absolute; display: none; border: 2px outset; z-Index: 200;'><div>" );

var hover = document.getElementById( "hover" ), abbrevs = {}, known = {}, counts = {}, columns = {}, types = {}, dbs = {}, arexp, joins = {};

function fetchtabs(dbname) {
  var res = xml4ext( ".special?_special=tables&_dbname="+dbname, 1 );
  for ( var i=0 ; i<res.length ; i++ )
    tables[tables.length] = dbname+".."+res[i];
  dbs[dbname] = 1;
}

function fetchcols(name,nowarn) {
  if ( name.match( /\.$/ ) )
	return [];
  if ( columns[name] && !nowarn )
    return columns[name];
  var res = xml4ext( ".special?_special=columns&_table="+name, 2 );
  if ( !res[0].length && !name.match( /title/ ) && !nowarn ) ///
    alert( "No columns returned for "+name );
  types[name] = [""].concat( res[1] );
  return columns[name] = ["*"].concat( res[0] );
}

function abbrev(name,nin) {
  var dbname = name.replace( /\.\.$/, "" ), n = nin;
  if ( dbname != name  ) {
    if ( !dbs[dbname] )
      fetchtabs( dbname );
    return " ";
  }
//  if ( known[name] )
//    return " "+known[name];

  if ( !n ) { 
    var last = name.replace( /^\w+\./, "" );
    var m = last.match( /[a-z]/ ) ?
	last.match( /(^|[_\\.])\w|[A-Z]/g ) :
	last.match( /(^|[_\\.])\w/g ), n = "";
    for ( var i=0 ; m && i<m.length ; i++ )
      n += m[i].substring( m[i].length-1 );
    if ( n.match(/^(at|as)$/) )
      n = n.substr(0,1);
    if ( 1 && abbrevs[n] && abbrevs[n] != name || known[name] )
      n += counts[n] = (counts[n]||0)+1;
    n = n.toLowerCase();
  }

  abbrevs[n] = name;
  known[name] = n;
  var artmp = "";
  for ( var i in abbrevs )
    artmp += (artmp?"|":"")+i;
  arexp = new RegExp( "\\b("+artmp+")\\.(\\w*)$", "i" );
  if ( !columns[name] ) {
    //if ( nin ) columns[name] = ["fetching..."];
    setTimeout( "fetchcols( '"+name+"', "+(nin?1:0)+" );", 100 );
  }
  return " "+n;
}

//alert(abbrev("monBon23M"));
//alert(abbrev("MON23_BON"));
//alert(abbrev("monM_bin"));

function fixon(on) {
  for ( var i in abbrevs )
    on = on.replace( new RegExp( "\\b"+abbrevs[i]+"\\.", "ig" ), i+"." );
  return on;
}

var selcount, selected = 0, selwidth, current, unique, replacement, r, old, left, active, tav = "";
var activeregexp = new RegExp( "\\b(?:(from|join|update|insert(?: into)?|delete(?: from)?|exec(?:ute)?(?:\\s*@\\w+\\s*=)?|edit) (?:[\\w.]+ \\w+, )*|\\w+\\.)?([\\w\\.]*)$", "i" );

function seta(txt) {
  ta.value = txt.replace( /\r*\n/g, "\r\n" );
}

function indexof(a,t) {
  for( var i=0 ; i<a.length ; i++ )
    if ( a[i] == t )
      return i;
  return -1;
}

function qq(txt) {
  return txt.match(/[^,] /) ? '"'+txt+'"' : txt;
}

function geton2( tabs ) {
    var join = xml4ext(".special?_special=natural&_table="+tabs.toString(), 4);
    var from = join[2][0], to = tabs[tabs.length-1];
    var fcol = join[3][0], tcol = join[1][0];

    for ( var i=1 ; i<join[0].length ; i++ )
    	joins[join[0][i]] = "on ("+join[0][i]+"."+join[1][i]+" = "+join[2][i]+"."+join[3][i]+")";

    return !tcol ? "" : " on ("+known[to]+"."+tcol+" = "+known[from]+"."+fcol+")";
}

function abbrev0(txt,from) {
  if ( from ) {
    tabs = [txt];
    counts = {};
    known = {};
    joins = {};
  }
  return abbrev(txt);
}

function replacer(txt) {
  if (active&&active[1]) //&& indexof(tabs,txt) == -1 )
    tabs[tabs.length] = txt;
//alert(tabs);
  var newtxt = old + (!selected ? unique : qq(txt) + (active&&active[1] ? 
	active[1].match(/^(from|join)/i) ? abbrev0(txt,active[1].match(/^from/))+
	(active[1].match(/^join/i) || 1 ? fixon(geton2(tabs)) : "") : 
	active[1].match(/^insert/i) ? " ("+fetchcols(txt).slice(1).join(", ")+")\n" :
	active[1].match(/^(exec|edit)/i) ? "" :
	(active[1].match(/^update/i) ? "\n    set " : "")+
	"\nfrom "+txt+abbrev(txt)+"\nwhere " : ""));
  if ( selected && old.match( /^from/i ) )
    newtxt = "select *\n"+newtxt;
  seta( newtxt+tav.substr(left.length+selwidth) );
  r.move("character",newtxt.length);
  r.select();
  if ( selected ) {
    hover.style.display = "none";
    hover.innerHTML = "";
    selected = 0;
  }
  else
    hover.style.left = r.boundingLeft+20;
  replacement = current = unqiue = null;
}

function hardsel(td) {
  selected = 1;
  active = left.match( activeregexp );
  replacer( td.children.length > 1 ? td.children[0].innerText : td.innerText );
}

var tdcell = "<tr><td nowrap onclick='return hardsel(this);'", 
	tdsel = " style='background-color: lightblue;'", comre;

function crexp(str) {
   return new RegExp( "^"+str.replace( /([.])/g, "\\$1" ), "i" );
}

function common(s1,s2) {
  if ( comre && s2.match( comre ) )
    return s1;
  for ( var i=0 ; i<s1.length && i<s2.length ; i++ )
    if ( s1.charCodeAt(i) != s2.charCodeAt(i) )
	break;
  s1 = s1.substr(0,i);
  comre = crexp( s1 );
  return s1;
}

var lstr, html;

function joiner(name) {
  if ( joins[name] )
    name = "<b title='"+joins[name]+"'>"+name+"</b>";  
  return name;
}

function filter(str,list,list2,reset) {
  if ( str != lstr || !html || 1 ) {
  html = "";
  if ( reset ) joins = {};
  var found, saveTop = hover.children.length ? 
	hover.children[0].scrollTop : 0, re = crexp( str );
  current = unique = comre = null;
  selcount = 0;
//  var until = selected ? Math.min(selected+20,list.length) : list.length;
  for ( var i=0 ; i<list.length ; i++ )
    if ( !str.length || list[i].match( re ) ) {
//    if ( !str.length || str == list[i].substring( 0, str.length ) ) {
      var name = list2 ? "<span>"+list[i]+"</span>" : list[i],
	type = (list2?"<i> "+list2[i]+"</i>":"")
      name = joiner( name );
      found = list[i];
      if ( ++selcount == selected ) {
	html += tdcell+tdsel+">"+name+type;
	current = found;
      }
      else
	html += tdcell+">"+name+type;
      if ( str.length )
        if ( unique == null )
	  unique = common( list[i], list[i] );
        else
	  unique = common( unique, list[i] );
	if ( selcount > 200 ) {
          html += tdcell+">... be more specific";
          break;
        }
    }
    if ( selcount == 1 ) { 
      html = tdcell+tdsel+">"+joiner(unique = current = found); /// unqiuqe
      selected=1;
    }
    lstr = str;
  }

  var cellHeight = 17, maxHeight = Math.min( ta.clientHeight, cellHeight*15 );
  hover.innerHTML = "<table class=rtab cellspacing=0>"+html;
  if( selcount*cellHeight > maxHeight )
    hover.innerHTML = "<div style='width: 150; height: "+maxHeight+
//	"; width:"+(hover.clientWidth+16)+
	"; overflow-y: scroll;'>"+
	"<table width='100%' class=rtab cellspacing=0>"+
	html+"</table></div>";
  hover.children[0].scrollTop =  selected ? (selected-1)*cellHeight : saveTop;
  return selcount && !(selcount==1 && str==found);
}

var ta, lastuniq, stack = [], deleteing, escaped = 0;

function keydn() {
  ta = this;
//alert(event.keyCode);
  var r = document.selection.createRange();
  if ( (event.keyCode == 8 || event.keyCode == 46) && 
		!deleteing || r.boundingWidth ) {
    stack.push( [ta.value] ); //, r] );
    deleteing = 1;
  }
  else if ( !(event.keyCode == 8 || event.keyCode == 46) )
    deleteing = 0;
  if ( (event.keyCode == 189 || event.keyCode == 191) &&
	event.ctrlKey && r.text ) {
    var t1 = r.text.replace( /\r/g, "" ),//.replace( /\r\n/g, "\n" ),
        re = "([^\\v]*)("+t1.replace( /([][.+*?$(){}])/g,"\\$1" )+")([^\\v]*)";
    var mat = ta.value.replace( /\r/g, "" ).match( new RegExp( re ) );
    t1 = t1.replace( /(^|\n)(--)*/g, t1.match( /^--/ ) ? "$1" : "$1--" );
    ta.value = mat[1]+t1+mat[3];
    r.move("character",mat[1].length);
    r.moveEnd("character",t1.length);
    r.select();
    return event.returnValue = false;
  }
  if ( hover && hover.style.display == "none" /*|| !fm._parse.checked*/ )
    return event.returnValue = true;
  if ( event.keyCode == 33 && hover.children.length )
    hover.children[0].scrollTop -= hover.clientHeight;
  else if ( event.keyCode == 34 && hover.children.length )
    hover.children[0].scrollTop += hover.clientHeight;
  else if ( event.keyCode == 38 && selected )
    this.onkeyup( selected = Math.max( 0, selected-1 ) );
  else if ( (event.keyCode == 39 || event.keyCode == 13) &&
	(current || unique && unique != lastuniq) ) {
    if ( current == "*" ) {
      var cols = columns[abbrevs[active[1]]].slice(1);
      for ( var i=1 ; i<cols.length ; i++ )
        cols[i] = active[0]+cols[i];
      replacement = cols.join(', ');
    }
    else
      replacement = current || (lastuniq = unique);
  }
  else if ( event.keyCode == 40 && selected < selcount )
    this.onkeyup( selected = Math.min( selected+1, selcount ) );
  else if ( event.keyCode == 27 ) {
    escaped = escaped == 1 ? 10000 : 1;
    r.text = "";
  }
  else
    return event.returnValue = true;

  return event.returnValue = false;
}

function keypress() {
  ta = this;
  if ( event.keyCode == 26 && event.ctrlKey && stack.length ) {
    event.returnValue = false;
    var last = stack.pop();
    seta( last[0] );
//    last[1].select();
  }    
}

var border = 3, fwidth=8, fheight = 16, ready = "";
var loffset0 = navigator.userAgent.match( /MSIE 10\.0/ ) ?
    parent.parent.frames[0].innerWidth : 0;

function keyup() {
  ta = this;
  if ( !hover )
    hover = document.getElementById( "hover" );

  window.onselmade && onselmade();
  if ( /*!fm._parse.checked ||*/ ta.value.match( /\t/ ) ) {
    hover.style.display = "none";
    hover.innerHTML = "";
    return;
  }
  r = document.selection.createRange();

  var x = ta, loffset=loffset0, toffset=0;
  while(x=x.offsetParent) {
    loffset += x.offsetLeft;
    toffset += x.offsetTop;
  }

  tav = ta.value.replace( /\r/g, "" );
  if ( !tav || tav.length > 10000 )
    return;

//alert(r.boundingLeft-ta.offsetLeft-loffset-5+" "+ta.offsetLeft+" "+ta.offsetTop);
//alert(""+r.boundingLeft+"-"+ta.offsetLeft+"-"+loffset+"-"+border);
  var cols = Math.floor((ta.clientWidth-2)/fwidth),
    col = Math.floor((r.boundingLeft-ta.offsetLeft-loffset-border)/fwidth),
    row = Math.floor(((r.boundingTop+ta.scrollTop*2)-ta.offsetTop-
	toffset+document.body.scrollTop-border)/fheight),
  //dv.innerText += r.boundingLeft+"x"+r.boundingTop+" "+ta.scrollTop+"="+col+","+row+"-\n";
    rexp = "^((?:.{0,"+cols+"}\\n?){"+row+"}.{"+col+"})([\\w.]*)";
//alert(rexp);
//alert(tav+"-"+rexp);
  var m = tav.match( rexp )||["","",""], before = m[1], after = m[2];
  left = before+after;
  selwidth = r.boundingWidth && ready.length; ready = "";
  left = left.substr( 0, left.length-selwidth );
  //dv.innerText += "?"+left.length+"?"+ta.value.length+"!"+left+"!";
  active = left.match( activeregexp );
//alert(active);
  var sofar = active ? active[2] : ""; 
  if ( !sofar ) escaped--;
  old = left.substr(0,left.length-sofar.length);

  //  alert("HERE "+left+" "+row+" "+col+" "+m);

  if ( replacement )
    return replacer( replacement );
  else if ( after.length == selwidth && //before == left && //(!after && !ready) &&
	escaped<0 && (active && active[1] &&
	filter(sofar, active[1].match(/^exec/i) ? procs : tables, null, active[1].match(/^from/i) ) ||
	(active = left.match( arexp )) && abbrevs[active[1]] &&
	filter(sofar,fetchcols(abbrevs[active[1]]),
				types[abbrevs[active[1]]])) ) {

    if ( event.keyCode != 8 && event.keyCode != 46 ) {
      if ( selcount==1 )//selected ) //////
        ready = current.substr(sofar.length);
      else if ( unique && unique.length > sofar.length )
        ready = unique.substr(sofar.length);
      if ( ready ) {// && !r.boundingWidth )
        seta( left+ready+tav.substr(left.length+selwidth) );
        r.move("character",left.length);
        r.moveEnd("character",ready.length);
        r.select();
      }
    }
    else {
      selected = 0;
      lastuniq = null;
    }

    hover.style.left = r.boundingLeft+r.boundingWidth+20;
    hover.style.top = 12+toffset;
    hover.style.display = "block";
    return;
  }

  replacement = current = lastuniq = null;
  hover.style.display = "none";
  hover.innerHTML = "";
  selected = 0;
}

//window.onload = function() {
if ( navigator.userAgent.match( /MSIE/ ) && tables ) {
  var tas = document.body.getElementsByTagName("TEXTAREA");

  for ( var i=0 ; i<tas.length ; i++ ) {
    var ta = tas[i];
    ta.onkeypress = keypress;
    ta.onmouseup = keyup;
    ta.onkeydown = keydn;
    ta.onkeyup = keyup;
    ta.setsql = function() {
	var tabs = this.value.match(/\b(?:from|join) ([\w.]+)\s(\w+\b)/g );
	for ( var i=0 ; tabs && i<tabs.length ; i++ ) {
	   var m = tabs[i].match( /^(?:from|join) ([\w.]+)\s(\w+\b)/ );
           abbrev(m[1],m[2]||"_________");
        }
    };
  }
  if ( tas.length > 1 )
    border = 5;
}
//}

if ( !window.fm )
  fm = {_parse:{},_server:{},_database:{}};

fm._parse.onmouseup = function(b) {
  var dt = new Date(); dt.setTime(dt.getTime()+90.*24*60*60*1000);
  document.cookie = "_jsql_parse="+(fm._parse.checked?"0":"1")+
	"; path=/; expires="+dt.toGMTString();
//  fm._database.onchange = fm._server.onchange;
  tabs = [];
};

//alert(document.cookie);
//if ( fm._parse.checked = document.cookie.match( /_jsql_parse=0;/ ) ? 0 : 1 )

  fm._database.onchange = fm._server.onchange;

fm.oldonsub = fm.onsubmit;
fm.onsubmit = function() {
  tabs = [];
  this.oldonsub();
}
