
/*
 * $Id: //depot/jhttpd/docs/jsqldocs/etab.js#7 $
 *
 * COPYRIGHT(C) 2003 Coldwave Programs Ltd. ALL RIGHTS RESERVED
 * for an updated copy of this file please go to www.dbexplorer.com
 *
 * By downloading this software you have agreed to the following terms:
 * This software is available free for individual use or evaluation only.
 * If you wish to incorporate ANY of the code in this release into
 * a product or production application a source license is required.
 * This software may not be redistributed whole or in part.
 *
 * THIS SOFTWARE IS PROVIDED BY COLDWAVE PROGRAMS LTD "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL COLDWAVE PROGRAMS LTD OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

function initUnscroll(row) {
  var tab = row.parentElement.parentElement;
  var sp;
  for ( sp = tab.parentElement ; sp ; sp = sp.parentElement )
    if ( sp.currentStyle.overflow == "auto" )
      break;

//  row.style.position = "static";
  row.scrollParent = sp || document.body;
  row.scrollParent.onscroll = function() {
    var sp = document.body; ///??? was this
    sp._scrollTop = sp.scrollTop;
    sp._scrollLeft = sp.scrollLeft;
  }

  tab.parentOffsetLeft = 0;
  tab.parentOffsetTop = 0;

  for ( var p = tab ; (p = p.offsetParent) && // p.tagName != "BODY" &&
	p.currentStyle.overflow != "auto" ; ) {
    tab.parentOffsetLeft += p.offsetLeft;
    tab.parentOffsetTop += p.offsetTop;
  }

  // alert("HERE"+this._scrollLeft+" "+row.scrollParent);
  return doUnscroll( row, row.scrollParent.scrollTop, row.scrollParent.scrollLeft );
}

// called when parent scroll position changes
// this works when there is no table border
function doUnscroll(row,top,left) {
  var tab = row.parentElement.parentElement;
  var hScroll = Math.max( -2, left-tab.offsetLeft-tab.parentOffsetLeft );
  hScroll = hScroll < tab.clientWidth-50 ? hScroll : 0;

  if ( tab.scrolledLeft != hScroll )
    tab.scrolledLeft = hScroll;

  var vScroll = Math.max( 0, top-tab.offsetTop-tab.parentOffsetTop );
  if ( vScroll ) //&& !row.style.position )
    row.style.position = "relative";
  else
    return -1;
  return vScroll < tab.clientHeight-50 ? vScroll-2 : -1;
}

if (navigator.userAgent.match( /MSIE/ ) && !window.noetab ) {
  document.write( "<style>\n\n"+
".vfix, .rtab thead tr { top: expression(this.scrollParent?this.parentElement&&doUnscroll(this, this.scrollParent._scrollTop, this.scrollParent._scrollLeft):initUnscroll(this)); zz-index: 1; }\n"
+".hfix, .rtab tbody th { left: expression(this.parentElement&&this.parentElement.parentElement.parentElement.scrolledLeft); position: relative; }\n\n"+
"</style>\n" );
}

var toSort;
function headerClick (r) {
  toSort = event.srcElement;
   document.body.style.cursor = "wait";
  setTimeout( "headerClick1()", 50 );
  return false;
}

function headerClick1 (r) {
  var cell = toSort; // event.srcElement;
  if ( cell.tagName.match( /IMG/ ) )
    cell = cell.parentElement;
  if ( !cell.tagName.match( /TD|TH/ ) )
    return true;

  var row = cell.parentElement;
  var cells = row.children;
  var tab = row.parentElement.parentElement;
  var hdrs = tab.children[0].children[0].children;

  if ( cells == hdrs && cell.tagName == "TH" ) {
    var i;

    for( i=0 ; i<hdrs.length ; i++ )
      if ( cell == hdrs[i] )
	break;

    if ( cell.style.fontStyle ) {
      for( i=0 ; i<hdrs.length ; i++ )
        cells[i].style.fontStyle = "";
      i = -1;
    }
    else
      cell.style.fontStyle = "italic";

    sortTable( tab, i );
  }

  return false;
}

window.MAX_ROWS = 1000;

function sortTable(tab,cno) {

  // create array object of non-fixed rows  
  if ( !tab.sortRows ) {
    tab.sortRows = [];
    tab.shadows = [];
    var i = 0;
    for ( var r=1 ; r<tab.rows.length && r<=MAX_ROWS ; r++ )
      if ( tab.rows[r].cells.length == tab.rows[0].cells.length ) {
        (tab.sortRows[i] = tab.rows[r]).idx = i;
	i++;
      }
      else
	tab.shadows[i] = tab.rows[r];
  }

  // column<0 resets list of sorts
  if ( cno<0 || !tab.sortRows.length ) {
    for ( var r=0 ; r<tab.sortRows.length ; r++ ) {
      tab.sortRows[r].style.top = 0;
      if ( tab.shadows[r] )
        tab.shadows[r].style.top = 0;
    }	
    tab.sorts = "";
    document.body.style.cursor = "";
    var dt = new Date();
    dt.setTime(dt.getTime()+-90.*24*60*60*1000);
      document.cookie 
	= tab.children[1].sortCookie+"=; expires="+dt.toGMTString();
    return;
  }

  if ( cno != null ) {
    // columns to be storted by are cumulative
    if ( !tab.sorts )
      tab.sorts = cno+1;
    else
      tab.sorts += ","+(cno+1);

  // construct the body of the comparison
  // function to be used by the array sort
  var cmp = "return ";
  var cs = (""+tab.sorts).split( "," );
  for( var c=0 ; c<cs.length ; c++ ) {
    var hdr = tab.rows[0].cells[cs[c]-1];
    cmp += (c?"||":"")+((hdr.type||hdr.title||"").match( 
		/int|num|dec|float|double|real|money/ ) ? 
		"(cln(b)-cln(a))" : "(a>b?1:a<b?-1:0)")
	.replace( /(a|b)/g, "$1.cells["+(cs[c]-1)+"].innerText.toLowerCase()" );
  }
  // alert(cmp);

  try {
    // sort rows into new order using dynamic comparison function
    var out = tab.sortRows = tab.sortRows.sort( new Function( "a,b", cmp ) );
    var h = tab.rows[1].clientHeight; // height of a row

    // reposition rows according to their new position
    for( var r=0 ; r<out.length ; r++ ) {
      out[r].style.top = (r-out[r].idx)*h; // simpler and safer
      out[r].style.position = "relative";
      if ( tab.shadows[r] ) {
        tab.shadows[r].style.top = (r-out[r].idx)*h;
        tab.shadows[r].style.position = "relative";
      }
    }

    if ( tab.children[1].sortCookie ) {
      var dt = new Date();
      dt.setTime(dt.getTime()+90.*24*60*60*1000);
      document.cookie 
	= tab.children[1].sortCookie+"="+tab.sorts+"; expires="+dt.toGMTString();
    }
  }
  catch ( e ) {
    alert( e.message );
  }
  }

  document.body.style.cursor = "";
}

function rememberSort(tab) {
  var ckhash = {};
  var cks = document.cookie.split( "; " );
  for ( var i=0 ; i<cks.length ; i++ ) {
    var ck = cks[i].match( /^([^=]+)=(.*)$/ );
    if ( ck && ck[1] )
      ckhash[ck[1]] = ck[2];
  }
  resort( tab, ckhash[tab.sortCookie] );
}

function resort(tab,prev) {
try {
  if( tab.parentElement.sorts = prev ) {
    // alert("here cookie "+tab.parentElement.sorts);
    var cols = tab.parentElement.sorts.split( "," );
    for ( var i=0 ; i<cols.length ; i++ )
      tab.parentElement.rows[0].cells[cols[i]-1].style.fontStyle = "italic";
    sortTable( tab.parentElement, null );
  }
}
catch ( e ) {
  alert( e.message );
}
}

function cln(n) {
  if ( n=='null' )
    return -0.001;
//log.value += ">"+n+"<";
  if ( n.charCodeAt(0) == 8722 )
    n = "-"+n.substring(1); // remove &minus;
  return n.replace(/,/g,'');
}

function exportTable(tab,delim) {
  var text = ""; // rows are exported in sorted order if there is one
  var rows = tab.sortRows ? [tab.rows[0]].concat( tab.sortRows ) : tab.rows;

  for( var r=0; r<rows.length ; r++ ) {
    var cols = rows[r].cells;
    for( var c=0 ; c<cols.length ; c++ )
      text += (c?delim||"\t":r?"\n":"")+cols[c].innerText.replace(/\t/g," ");
  }

  window.clipboardData.setData( "Text", text );
}
