/*
    menu.js - $Id: menu.js,v 3.3 2002/06/18 10:58:10 johnh Exp $
    =======

  Simple Menu creation routines for Internet Explorer.
  Copyright(c) John Holdsworth 2002. All rights reserved.

  This software is provided as is without Warantee implied
  or expressed and must not be redistributed.
*/

function Menu (name, list) {
  this.html = "";
  this.name = name;

  if ( list ) {
    for ( var i = 0 ; i<list.length ; i++ )
	this.item( list[i][0], list[i][1], list[i][2] );

    this.close( document );
  }
}

function Menu.prototype.item (contents, callback, title) {
  if ( contents ) {
    var tags = "";

    if ( callback )
      tags += " callback='"+callback+"'";
    else
      tags += " class='mtitle'";
 
    if ( title )
      tags += " title='"+title+"'";

    this.html += "<span"+tags+">"+contents+"</span><br>";
  }
  else
    this.html += "<hr>";
}

function Menu.prototype.submenu (contents, name) {
    this.html += "<span submenu='"+name+"'>"+contents+" ...</span><br>";
}

function Menu.prototype.close( document ) {
  if ( document.all[this.name] )
    document.all[this.name].innerHTML = this.html;
  else
    document.write( "<div class='contextMenu' id='"+
		this.name+"'>"+this.html+"</div>" );
}


function mapMenu(menu, item) {
    var body = menu.document.body;
    var event = menu.document.parentWindow.event;

    menu.parentItem = item;
    menu.style.display = "block";

    var superMenu = menu.parentItem.parentElement;

    menu.style.top  = body.scrollTop + 
	(event.clientY + menu.clientHeight > body.clientHeight ? 
	body.clientHeight - menu.clientHeight - 4 : 
	event.clientY  - 10 );

    menu.style.left = menu.parentItem.submenu ?
	superMenu.offsetLeft + superMenu.offsetWidth - 5 :
	event.clientX + body.scrollLeft  - 10;

    if ( menu.offsetLeft + menu.offsetWidth - body.scrollLeft
		> body.clientWidth )
	menu.style.left = body.clientWidth + body.scrollLeft - 
	(menu.parentItem.submenu? 2 : 1) * menu.offsetWidth;

    menu.onmouseover = highlight;

    menu.setCapture();
    return event.returnValue = false;
}

function highlight(fg, bg) {
  var event = this.document.parentWindow.event;
  var item = event.srcElement;

  if( item.callback || item.submenu ) {
    var menu = item.parentElement;

    unhighlight( menu );

    var submenu = item.submenu;
    if( submenu ) {
      submenu = this.document.all[submenu];
      if ( submenu.style.display != "block" )
	 mapMenu( submenu, item );
    }

    item.style.backgroundColor = bg;
    item.style.color = "red";
    menu.lastItem = item;
  }
}

function unhighlight (menu) {
    var lastItem = menu.lastItem;

    if ( lastItem ) {
      if ( lastItem.submenu != menu.id && lastItem.parentElement ) {
        var style = lastItem.parentElement.style;
        lastItem.style.backgroundColor = style.backgroundColor;
	lastItem.style.color = "gold";
	unmapMenu( lastItem.submenu );
      }
    }
}

function unmapMenu(menuName) {
  if ( menuName ) {
    var menu = window.gui.document.all[menuName];
    menu.style.display = "none";
    menu.releaseCapture();
    unhighlight( menu );
    if ( menu.lastItem )
      unmapMenu( menu.lastItem.submenu );
  }
}

