/*
	$Id: ytab.js,v 1.11 2002/08/31 07:47:11 johnh Exp $
	
	implementation of "locked column" HTML table element.
*/

document.write( " ");

dataXML.async = false;

var xmlObject = new XmlObject( dataXML );

var transform = '<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">\
<xsl:template match="/">\
<xsl:for-each select="//row"><tr><COLUMNS/></tr></xsl:for-each>\
</xsl:template></xsl:stylesheet>';

function XmlObject ( XMLisland ) {
  XMLisland.async = false;
  var columnNodes = XMLisland.selectNodes( "//column" );
  var columnNode, columnNumber = 0;

  while ( columnNode = columnNodes.nextNode() ) {
    var columnInfo = this[columnNumber] = {};
    var attributes = columnNode.attributes;
    columnInfo.attr = "@c"+columnNumber++;    

    for ( var attrNo=0; attrNo<attributes.length ; attrNo++ )
	columnInfo[attributes[attrNo].nodeName] = attributes[attrNo].nodeValue;

    columnNode.parentNode.removeChild( columnNode );
  }

  this.island = XMLisland;
  this.length = columnNumber-1;
  this.page = this.pages = 0;

  var page, row, rows = this.island.selectNodes( "//row" );

  for ( var rno=0 ; rno<rows.length ; rno++ ) {
    if ( rno % 20 == 0 ) {
      page = this.island.createNode( 1, "grp"+(rno/20), "" );
      this.island.documentElement.appendChild( page );
      this.pages++;
    }

    page.appendChild( rows[rno] );
  }

//alert( this.island.xml );

  return this;
}

function tag( name, value ) {
  return "<"+name+">"+value+"</"+name.replace( / .*/, "" )+">";
}

function XmlObject.prototype.rowsHTML ( tableAttributes, preventLineBreaks,
					formatFloats, cols, start, end ) {
  var columnXSL = "";
  var html = "";
  cols = cols || this;

  // build up XSL to select column values and header html
  for( var colNo=1 ; colNo<cols.length ; colNo++ ) {
    var column = cols[colNo];
    var type = column.type;
    var align = type.match( /text/ ) ? "" : " align='right'";
    var select = "./"+column.attr;

    // this is how to put commas into float values
    // alas this is not supported by most browsers
    // which have MSXML 2.5-6 installed by default
    if ( false && formatFloats && type.match( /float/ ) )
      select = "format-number( "+select+", ',##0.00' )";

    if ( colNo == 1 && cols.length == 2 && this.pages > 1 ) {
	align += " colspan=\"4\"";
	var gg = tag( "th title='next' style='width:10' onclick='parent.xmlObject.pag(this.innerText)'", "--" );
	if ( this.page ) {
	  html += gg.replace( /--/, "^" );
	  html += gg.replace( /--/, "<" );
	}
	else
	  html += gg.replace( /--/, "print" );

	if ( this.page < this.pages-1 )
	  html += gg.replace( /--/, ">" );
    }

    html += tag( "th align=left widsth='500%' title='"+column.dbtype+
	"' id=heading_"+column.name, column.name );

    columnXSL += "<td"+align+"><xsl:value-of select=\""+select+"\"/></td>";
  }

  // wrap headings with floating tr element
  html = tag( "tr id=tableHeading", html );
  

  // build the XSL transform to build table rows
  var outputXSL = this.island.cloneNode(false);
  var xsl =  transform.replace( /<COLUMNS\/>/, columnXSL );

  if ( this.page != null )
    xsl = xsl.replace( "//row", "//grp"+this.page+"/row" )

  outputXSL.loadXML( xsl ) || alert( "Could not load XSL:\n"+xsl );

  // transform the xml data island into the html table rows
  html += this.island.transformNode( outputXSL );

  // replace whitespace and any hyphens
  if ( preventLineBreaks )
    html = html.replace( /\t/g, "&nbsp;" );

  html = html.replace( /-/g, "&minus;" ).replace( /~/g, "'" );

  // give table a parent it can be replaced
  return html;
}

function XmlObject.prototype.tableHTML ( tableAttributes, preventLineBreaks,
					formatFloats, cols, start, end ) {
  return tag( "div id=tableParent", tag( "table"+tableAttributes,
	this.rowsHTML( tableAttributes, preventLineBreaks,
					formatFloats, cols, start, end )));
}

function XmlObject.prototype.pag (txt) { with (this) {
//  alert( txt+this.page );
  if ( txt == "print" ) {
	var win = window.open( "", "printable", "" );
	win.document.write( "<html><head><title>hi there</title></head>"+
	"<body>"+embossedStyle+"<table"+embossedTable+">" );

	for ( page=0 ; page<pages ; page++ ) {
	   html = xmlObject.rowsHTML( embossedTable, true, true );	

           if ( page>0 )
		html = html.replace( /<tr/, "<tr style='page-break-before: always'" );
	   win.document.write( html );
	}
	
	win.document.write( "</table>" );
	win.focus();
	return
  }

  page = txt == "^" ? 0 : txt == "<" ? !page ? 0 : page-1 : page+1;
  frames[0].document.open();
  frames[0].document.write( lockedFrameHTML() );
  frames[0].document.close();
  frames[1].document.open();
  frames[1].document.write( scrollingFrameHTML() );
  frames[1].document.close();
} }

// inline style tag for page
var embossedStyle = tag( "style type='text/css'", "h2 { color: gold; }\
body { background-color: darkblue; } table { color: 70ff00 }\
th { background-color: darkblue; color: gold; font: bold 10pt Verdana;} }\
td { background-color: blue; font: 8pt Verdana;}" );

var embossedTable = " border=2 cellspacing=0 cellpadding=1"+
		" bordercolorlight=black bordercolordark=lightblue";

function trackHeader () { with (this) {
  var heading = tableHeading;
  var lockingFrame = parent.frames[0];
  var locking = lockingFrame ? lockingFrame.tableHeading : null;

  if ( !heading.orig )
	heading.orig = heading.parentElement.parentElement.offsetTop;
 
  if ( this.document.body.scrollTop > heading.orig ) {
    if ( lockingFrame ) {
        locking.style.top = document.body.scrollTop-heading.orig-3;
	locking.style.position = "relative";
    }

    heading.style.top = document.body.scrollTop-heading.orig-3;
    heading.style.position = "relative";
  }
  else {
    if ( lockingFrame ) {
      locking.style.top = -2; locking.style.left = -2;
    }

    heading.style.top = -2; heading.style.left = -2;
  }

  if ( lockingFrame )
    lockingFrame.document.body.scrollTop = document.body.scrollTop;
} }

function lockedFrameHTML () {
  return tag( "html", tag( "body leftmargin=0 topmargin=0", embossedStyle+
		tag( "div id=pad", "" )+
		xmlObject.tableHTML( embossedTable+" id=lockedTable", 
		 true, true, [null, xmlObject[1]] ))+"<br><br><br><br><br>");
}

function scrollingFrameHTML () {
  var cols = [];
  for ( var colNo=2 ; colNo<=xmlObject.length ; colNo++ )
      cols[colNo-1] = xmlObject[colNo];

  return tag( "html", tag( "body leftmargin=0 topmargin=0", embossedStyle+
		tag( "script", "onload = parent.alignOnLoad;\n"+
//		  "onbeforeprint = parent.prepareForPrint;\n\n"+
		  "\n\nonscroll = parent.trackHeader;\n\n" )+"\n"+
		xmlObject.tableHTML( embossedTable+" id=scrollTable", 
		true, true, cols )));
}

function alignOnLoad () { with (this) {
  var lockedFrame  = this.parent.frames[0];
//  lockedFrame.pad.style.height = scrollTable.offsetTop;
  parent.document.all.fset.cols = lockedFrame.lockedTable.offsetWidth-2+",*";
} }

function basicFrame() {
  document.write( "<frameset cols=1,* border=1 id=fset>\
<frame src='javascript: parent.lockedFrameHTML()' scrolling=no>\
<frame src='javascript: parent.scrollingFrameHTML()'>\
</frameset>\
" );
}

/*
    this was realy pushing the envelope and awaits
    descent printing support. Two things missing are:
    1) application of @media print properties
       before onbeforeprint is called and ...
    2) the document size to become the page size
*/

function prepareForPrint () { with (this) {
  document.body.style["font"] = "5 pt serif";
  this.parent.frames[0].document.body.style["font"] = "5 pt serif";

  var lockedFrame  = this.parent.frames[0];
  lockedFrame.pad.style.height = scrollTable.offsetTop;
  parent.document.all.fset.cols = lockedFrame.lockedTable.offsetWidth-2+",*";
} }

onbeforeprint = prepareForPrint;
